#ifndef __MIXER_PROTOS_H
#define __MIXER_PROTOS_H

/*
** Infos sur un lment du mixeur. 
*/

#include<stdio.h>
#include"MixerCurvesProtos.h"
#include"TempGmurf.h"
#include"DspLib.h"

typedef struct s_mixer_info t_mixer_info;
struct s_mixer_info
{
  size_t     begin_date;
  float      volume;
  BOOL       do_freq;
  float      panning;
  t_instrux* first_instrux;
  t_point*   vol_curve; /* Premier point de la courbe de volume */
  t_point*   pan_curve; /* Premier point de la courbe de panning */  
  t_point*   frq_curve; /* Premier point de la courbe de frquence */

}; /* t_mixer_info */

/*
** Un lment du mixeur.
*/
typedef struct s_mixer_elt t_mixer_elt;
struct s_mixer_elt
{
  t_tempgmurf*  tempgmurf;           /* fichier temporaire assici */
  t_dsp*        dsp;                 /* fichier DSP associ */
  BOOL          rec_or_play;         /* TRUE si le fichier est  enregister */
  BOOL          mute;                /* TRUE si la voix est tue */
  BOOL          finished;            /* TRUE si on a fini de dcoder */
  t_mixer_info* mixer_info;          /* infos pour le mixer */
  t_mixer_elt*  next_mixer_elt;      /* Pointeur sur le suivant */
  short int     buffer[BUFFER_SIZE]; /* Buffer */
  size_t        read_bytes;          /* Nb d'octets lus ds le buffer */
};

/*
** Point de dpart de la liste chane.
*/
typedef struct s_main_mixer t_main_mixer;
struct s_main_mixer
{
  t_dsp*       dsp;             /* dsp qui lui est associ par dfaut. */
  t_mixer_elt* first_mixer_elt; /* Premier lment du mixeur */
  float        vol;             /* Volume gnral du mixeur */
  int          frq;             /* Frquence gnrale du mixeur */
  int          pan;             /* Balance gnrale */
  int          nb_voices;       /* Nombre de voix */
  size_t       played_samples;  /* Temps coul depuis le dpart */
};

#endif
