#include <fcntl.h>
#include <unistd.h>
#ifdef TEXT_MSG
#include <stdio.h>
#include <errno.h>
#include "Errors.h"
#endif
#include "WaveHeader.h"


/*
** ouvre un fichier WAV et retourne une structure 't_wave_file' 
*/
t_wave_file wave_open(wav_path)
     char *wav_path;
{
  t_wave_file temp_wav;
  
  temp_wav.file = open(wav_path, O_RDONLY);
  if (temp_wav.file == -1)
    {
#ifdef TEXT_MSG
      printf ("erreur lors de l'ouverture du fichier '%s'\n", wav_path);
      if  (errno == EACCES) printf ("%s\n", BAD_RIGHT);
      if ((errno == EFAULT) || (errno == ENOENT)) printf ("%s\n", BAD_FILE);
#endif
    }
  return (temp_wav);
}

/*
** ferme un fichier WAV
*/
void wave_close(wav)
     t_wave_file wav;
{
  close(wav.file);
}

/*
** appel 'wav_open' pour ouvrir un WAV puis lit son entete 
*/
t_wave_file wave_read_header(wav_path)
     char *wav_path;
{
  t_wave_file temp_wav;

  temp_wav = wave_open(wav_path);
  if (temp_wav.file != -1)
    read(temp_wav.file, (void *) &temp_wav.header, sizeof (t_wave_header));
  return (temp_wav);
}
 
/*
** renvoie 1 si l'entete du WAV passe en argument est bonne et 0 sinon
*/
int is_wave(wave_header)
     t_wave_header wave_header;
{
  if (memcmp (wave_header.wave_fmt_str, "WAVEfmt ", 8) == 0)
    return (1);
  else
      return (0);
}



